#include"array.h"

Array::Array(int r_num, int c_num)
{
  rows=(r_num >= 1  ? r_num : 2 );
  columns=(c_num >= 1 ? c_num : 2);
  size = rows*columns;
  ptr_arr = new int [size];
}


Array::Array(const Array& rif_arr)
{
  rows=rif_arr.rows;
  columns=rif_arr.columns;
  size=rif_arr.size;
  ptr_arr = new int [size];
  for(int i=0; i<size; i++)
    ptr_arr[i]=rif_arr.ptr_arr[i];
}


Array::~Array()
{
  delete[] ptr_arr;
}


int Array::getRows() const
{
  return rows;
}


int Array::getColumns() const
{
  return columns;
}


ostream& operator<<(ostream& output, const Array& array)
{
  int count=0;
  for(int i=0; i<array.rows; i++)
    {
      for(int j=0; j<array.columns; j++)
	{
	  output << array.ptr_arr[count] << " ";
	  count++;
	}
      output << endl;
    }
  return output;
}


istream& operator>>(istream& input, Array& array)
{
  for(int i=0; i<array.size; i++)
    input >> array.ptr_arr[i];
  return input;
}


bool Array::operator==(const Array& array) const
{
  if(rows != array.rows)
    return false;
  if(columns != array.columns)
    return false;
  int ctr=0;
  for(int i=0; i<size; i++)
    {
      if(ptr_arr[i]!=array.ptr_arr[i])
	return false;
    }

  return true;    
}


bool Array::operator!=(const Array& array) const
{
  if(*this == array) 
    return false;
  else
    return true;
}


Array& Array::operator=(const Array& array)
{
  if(size != array.size)
    {
      delete [] ptr_arr;
      size=array.size;
      ptr_arr = new int [size];
      rows=array.rows;
      columns=array.columns;
    }
  for(int i=0; i<size; i++)
    ptr_arr[i]=array.ptr_arr[i];

  return *this;      
}


void Array::operator()(int row_i, int col_i, int value)
{
  if(row_i>rows || col_i>columns)
    {
      cout << "Error in the dimensions" << endl;
      return;
    }
  
  int count=0;
  for(int i=0; i<rows; i++)
    {
	  for(int j=0; j<columns; j++)
	    {
	    if( i+1==row_i && j+1==col_i)
	      {
	      ptr_arr[count]=value;
	      }  
	    count++;
	    }
    }

}


const int Array::operator()(int row_i, int col_i) const
{
  if(row_i>rows || col_i>columns)
    {
      cout << "Error in the dimensions";
      return 0;
    }
  
  int count=0;
  for(int i=0; i<rows; i++)
    {
	  for(int j=0; j<columns; j++)
	    {
	    if( i+1==row_i && j+1==col_i)
	      return ptr_arr[count];
	    count++;
	    }
    }
}
